using System;
using System.ComponentModel;

namespace Common.Model
{
    /// <summary>
    /// Base class for an IdentifiedObject that has a name
    /// </summary>
    [Serializable]
    public class NamedOjbect<IDType> : IdentifiedObject<IDType>
    {
        private string _name;

        public virtual string Name
        {
            get { return _name; }
            set { _name = value; }
        }

        public override string ToString()
        {
            return Name;
        }
    }
}
