using System;
using System.Collections.Generic;
using System.Text;
using System.ComponentModel;
using System.Collections.ObjectModel;
using System.Web.UI;

namespace Common.Web.CustomControls
{
    [
    PersistChildren(false),
    ParseChildren(true),
    TypeConverter(typeof(ExpandableObjectConverter))
    ]
    public class DataTableAdapterConfig
    {
        private bool _autoGenerateColumns = true;

        [DefaultValue(true)]
        [NotifyParentProperty(true)]
        public bool AutoGenerateColumns
        {
            get { return _autoGenerateColumns; }
            set { _autoGenerateColumns = value; }
        }

        private Collection<PropertyColumn> _columns = new Collection<PropertyColumn>();
        [
        Description("List of columns"),
        PersistenceMode(PersistenceMode.InnerProperty),
        DefaultValue((string[])null)
        ]
        [NotifyParentProperty(true)]
        public Collection<PropertyColumn> Columns
        {
            get { return _columns; }
        }


        private string[] _propertiesToIgnore;

        [TypeConverter(typeof(System.Web.UI.WebControls.StringArrayConverter))]
        [NotifyParentProperty(true)]
        public string[] PropertiesToIgnore
        {
            get { return _propertiesToIgnore; }
            set { _propertiesToIgnore = value; }
        }

    }
    public class PropertyColumn : Common.Data.PropertyColumn
    {
        [Browsable(false)]
        public new Type Type { 
            get { return base.Type; }
            set { base.Type = value; }
        }

        private string _typeName;
        [NotifyParentProperty(true)]
        public virtual string TypeName
        {
            get { return _typeName; }
            set { _typeName = value; }
        }

        private string _updatePropertyName;
        [NotifyParentProperty(true)]
        public virtual string UpdatePropertyName
        {
            get { return _updatePropertyName; }
            set { _updatePropertyName = value; }
        }

    }
}
