using System;
using System.Collections;
using System.Collections.Generic;
using System.Text;
using NHibernate;
using System.Web.UI;
using System.ComponentModel;
using Common.Data.Hibernate;

namespace Common.Web.CustomControls
{

    public class NHibernateSelectingArgs : CancelEventArgs
    {
        public NHibernateSelectingArgs(
            string query, 
            NamedQueryParameterCollection parameters,
            DataSourceSelectArguments arguments, 
            bool executingSelectCount)            
        {
            this._query = query;
            this._parameters = parameters;
            this._arguments = arguments;
            this._executingSelectCount = executingSelectCount;
        }


        public DataSourceSelectArguments Arguments
        {
            get
            {
                return this._arguments;
            }
        }

        public bool ExecutingSelectCount
        {
            get
            {
                return this._executingSelectCount;
            }
        }

        private DataSourceSelectArguments _arguments;
        private bool _executingSelectCount;

        private string _query;
        public string Query
        {
            get { return _query; }
            set { _query = value; }
        }

        private NamedQueryParameterCollection _parameters;
        public NamedQueryParameterCollection Parameters
        {
            get { return _parameters; }
        }


    }
}
