using System;
using System.Web;
using Common.Data.Hibernate;

namespace Common.Web.Module {
	/// <summary> 
	///		HttpModule to automatically close a session at the end of a request 
	/// </summary> 
	public class NHibernateModule : IHttpModule {
		public void Init(HttpApplication context) { 
			context.EndRequest += new EventHandler(EndRequest); 
		}

		public void Dispose() {}

		public void EndRequest(Object sender, EventArgs e) {
			SessionHolder.CloseCurrentSession();
		}
	}
}
