using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using Northwind.Model;
using Common.Web.CustomControls;


public partial class Customers_Edit : System.Web.UI.Page
{

    protected void Page_Init(object sender, EventArgs e)
    {
        base.OnPreInit(e);
        if (Request["Id"] == null)
        {
            FormView1.ChangeMode(FormViewMode.Insert);
            
            pnlOrders.Visible = false;
        }
    }

    protected void Page_PreRender(object sender, EventArgs e)
    {        
        lblNoDemographics.Visible = pnlOrders.Visible && GridView3.Rows.Count == 0;        
        pnlOrderDetail.Visible = GridView1.SelectedValue != null;
    }

    /// <summary>
    /// After inserting a new record, redirect to this page with the correct id
    /// </summary>
    protected void dsCustomer_Inserted(object sender, NHibernateEntityEventArgs e)
    {
        Response.Redirect("Edit.aspx?Id=" + ((Customer)e.Entity).Id);
    }

    /// <summary>
    /// If an Insert is cancelled, redirect back to the customer list
    /// </summary>        
    protected void FormView1_ItemCommand(object sender, FormViewCommandEventArgs e)
    {
        if (e.CommandName == "Cancel" && FormView1.CurrentMode == FormViewMode.Insert)
        {
            Response.Redirect("Default.aspx");
        }
    }
}
