<%@ Page Language="C#" AutoEventWireup="true" CodeFile="Default.aspx.cs" Inherits="_Default"
    MasterPageFile="~/Default.master" Title="Order Search" %>

<asp:Content ID="cphldBody" ContentPlaceHolderID="cphldBody" runat="server">
    <em>Paging is enabled on the DataSource in order to save unnecessary data retrieval.&nbsp;
        Try searching for everything and then observing the differences in performance when
        EnablePaging is on/off.</em><br />
    <br />
    From:
    <asp:TextBox ID="txtStartDate" runat="server"></asp:TextBox>
    To:<asp:TextBox ID="txtEndDate"
        runat="server"></asp:TextBox>
    <asp:Button ID="btnSearch" runat="server" Text="Search" /><br />
    <br />

    <cp:NHibernateDataSource runat="server" ID="dsOrders"
        Query="Select o.OrderDate, o.Customer.CompanyName from Northwind.Model.Order o" 
        DefaultSortExpression="OrderDate DESC" 
        ExcludeEmptySelectParameters="True" 
        GenerateDataTable="True" 
        EnablePaging="True" 
        >
        <SelectParameters>
            <asp:ControlParameter ControlID="txtStartDate" Name="StartDate" PropertyName="Text" />
            <asp:ControlParameter ControlID="txtEndDate" Name="EndDate" PropertyName="Text" />
        </SelectParameters>
        <ParameterExtenders>
            <cp:ParameterExtender Name="StartDate" WhereCompareOperator="&gt;=" PropertyName="OrderDate" />
            <cp:ParameterExtender Name="EndDate" WhereCompareOperator="&lt;=" PropertyName="OrderDate" />
        </ParameterExtenders>
    </cp:NHibernateDataSource>
    
    <asp:GridView ID="gvOrders" runat="server" AllowPaging="True" DataSourceID="dsOrders"
        PageSize="20" 
        AutoGenerateColumns="False" 
        CssClass="dataGrid"         
        EnableViewState="False" AllowSorting="True"        
        >
        <PagerSettings Position="TopAndBottom" />
        <HeaderStyle CssClass="header" />
        <Columns>
            <asp:BoundField DataField="Column0" DataFormatString="{0:d}" HeaderText="Date" SortExpression="OrderDate" />
            <asp:BoundField DataField="Column1" HeaderText="Customer" SortExpression="o.Customer.CompanyName" />
        </Columns>
    </asp:GridView>
    
</asp:Content>
