using System;
using System.Collections.Generic;
using System.Text;
using NHibernate;

namespace Northwind.Model
{
    public class NorthwindInterceptor : IInterceptor
    {
        #region IInterceptor Members

        public int[] FindDirty(object entity, object id, object[] currentState, object[] previousState, string[] propertyNames, NHibernate.Type.IType[] types)
        {
            return null;
        }

        public object Instantiate(Type type, object id)
        {
            return null;
        }

        public object IsUnsaved(object entity)
        {
            OrderDetail orderDetail = entity as OrderDetail;
            if (orderDetail != null)
            {
                return !orderDetail.IsPersisted;
            }
            return null;
        }

        public void OnDelete(object entity, object id, object[] state, string[] propertyNames, NHibernate.Type.IType[] types)
        {
        }

        public bool OnFlushDirty(object entity, object id, object[] currentState, object[] previousState, string[] propertyNames, NHibernate.Type.IType[] types)
        {
            return false;
        }

        public bool OnLoad(object entity, object id, object[] state, string[] propertyNames, NHibernate.Type.IType[] types)
        {
            OrderDetail orderDetail = entity as OrderDetail;
            if (orderDetail != null)
            {
                orderDetail.IsPersisted = true;
                return true;
            }
            return false;
        }

        public bool OnSave(object entity, object id, object[] state, string[] propertyNames, NHibernate.Type.IType[] types)
        {
            OrderDetail orderDetail = entity as OrderDetail;
            if (orderDetail != null)
            {
                orderDetail.IsPersisted = true;
                return true;
            }
            return false;
        }

        public void PostFlush(System.Collections.ICollection entities)
        {
        }

        public void PreFlush(System.Collections.ICollection entities)
        {
        }

        #endregion
    }
}
