using System;
using System.Collections.Generic;

namespace Northwind.Model
{
    public class Order : Common.Model.IdentifiedObject<int?>
    {
        
        private IList<OrderDetail> m_OrderDetails;
        private Customer m_Customer;
        private Employee m_Employee;
        private System.DateTime? m_OrderDate;
        private System.DateTime? m_RequiredDate;
        private System.DateTime? m_ShippedDate;
        private Shipper m_ShipVia;
        private System.Decimal m_Freight;
        private System.String m_ShipName;
        private System.String m_ShipAddress;
        private System.String m_ShipCity;
        private System.String m_ShipRegion;
        private System.String m_ShipPostalCode;
        private System.String m_ShipCountry;



        public IList<OrderDetail> OrderDetails
        {
            get
            {
                return m_OrderDetails;
            }
            set
            {
                m_OrderDetails = value;
            }
        }

        public Customer Customer
        {
            get
            {
                return m_Customer;
            }
            set
            {
                m_Customer = value;
            }
        }

        public Employee Employee
        {
            get
            {
                return m_Employee;
            }
            set
            {
                m_Employee = value;
            }
        }

        public System.DateTime? OrderDate
        {
            get
            {
                return m_OrderDate;
            }
            set
            {
                m_OrderDate = value;
            }
        }

        public System.DateTime? RequiredDate
        {
            get
            {
                return m_RequiredDate;
            }
            set
            {
                m_RequiredDate = value;
            }
        }

        public System.DateTime? ShippedDate
        {
            get
            {
                return m_ShippedDate;
            }
            set
            {
                m_ShippedDate = value;
            }
        }

        public Shipper ShipVia
        {
            get
            {
                return m_ShipVia;
            }
            set
            {
                m_ShipVia = value;
            }
        }

        public System.Decimal Freight
        {
            get
            {
                return m_Freight;
            }
            set
            {
                m_Freight = value;
            }
        }

        public System.String ShipName
        {
            get
            {
                return m_ShipName;
            }
            set
            {
                m_ShipName = value;
            }
        }

        public System.String ShipAddress
        {
            get
            {
                return m_ShipAddress;
            }
            set
            {
                m_ShipAddress = value;
            }
        }

        public System.String ShipCity
        {
            get
            {
                return m_ShipCity;
            }
            set
            {
                m_ShipCity = value;
            }
        }

        public System.String ShipRegion
        {
            get
            {
                return m_ShipRegion;
            }
            set
            {
                m_ShipRegion = value;
            }
        }

        public System.String ShipPostalCode
        {
            get
            {
                return m_ShipPostalCode;
            }
            set
            {
                m_ShipPostalCode = value;
            }
        }

        public System.String ShipCountry
        {
            get
            {
                return m_ShipCountry;
            }
            set
            {
                m_ShipCountry = value;
            }
        }

    }
}