using System;
using System.Collections.Generic;
using NHibernate;

namespace Northwind.Model
{
    public class OrderDetail
    {
        //Had to override Equals and HashCode because of Composite-Id
        public override bool Equals(object obj)
        {
            if (base.Equals(obj))
                return true;

            if (obj != null && this.GetType().IsInstanceOfType(obj))
            {
                OrderDetail d = (OrderDetail)obj;
                return this.Order.Equals(d.Order) && this.Product.Equals(d.Product);
            }
            return false;
        }

        public override int GetHashCode()
        {
            return this.Order.GetHashCode() + this.Product.GetHashCode();
        }

        private bool m_IsPersisted;

        public virtual bool IsPersisted
        {
            get { return m_IsPersisted; }
            set { m_IsPersisted = value; }
        }


        private Order m_Order;
        private Product m_Product;
        private System.Decimal m_UnitPrice;
        private System.Int16 m_Quantity;
        private System.Single m_Discount;

        public Order Order
        {
            get
            {
                return m_Order;
            }
            set
            {
                m_Order = value;
            }
        }

        public Product Product
        {
            get
            {
                return m_Product;
            }
            set
            {
                m_Product = value;
            }
        }

        public System.Decimal UnitPrice
        {
            get
            {
                return m_UnitPrice;
            }
            set
            {
                m_UnitPrice = value;
            }
        }

        public System.Int16 Quantity
        {
            get
            {
                return m_Quantity;
            }
            set
            {
                m_Quantity = value;
            }
        }

        public System.Single Discount
        {
            get
            {
                return m_Discount;
            }
            set
            {
                m_Discount = value;
            }
        }

    }
}